--Ghosts! dot lua
--ghosts for the SMK ghost valley skybox

freeslot(
	"MT_SMKGV_GHOSTSPAWNER",
	"MT_SMKGV_GHOST",
	"S_SMKGV_GHOSTSPAWNER",
	"S_SMKGV_GHOST",
	"SPR_GVHY"
)

--we did the ghosts
local ghostSpawnerMo = nil
local ghostDistance = 416
local ghostSpeed = FRACUNIT
local ghostCount = 30

local function ghostSpawner(mo)
	--print("Running ghost spawner spawn function")
	ghostSpawnerMo = mo --{x=mo.x, y=mo.y, z=mo.z}
	for i = 1, ghostCount do
		local ghost = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMKGV_GHOST)
		ghost.angle = P_RandomKey(360)*ANG1
		ghost.zspawn = mo.z + (P_RandomFixed()-(FRACUNIT/2))*64
		ghost.rotspeed = FixedAngle(FixedMul((P_RandomFixed()-(FRACUNIT/2))/2, ghostSpeed))
		ghost.frame = $|(P_RandomKey(10)<<FF_TRANSSHIFT)
	end
end

addHook("MobjSpawn", ghostSpawner, MT_SMKGV_GHOSTSPAWNER)

local function ghostSpawnerThink(mo)
	ghostSpawnerMo = mo
end

addHook("MobjThinker", ghostSpawnerThink, MT_SMKGV_GHOSTSPAWNER)

local function ghostThink(mo)
	if not (ghostSpawnerMo and ghostSpawnerMo.valid) then return end
	local spawner = ghostSpawnerMo
	P_TeleportMove(mo, spawner.x + sin(mo.angle)*ghostDistance,
					   spawner.y + cos(mo.angle)*ghostDistance,
					   mo.zspawn)
	mo.angle = $+mo.rotspeed
end

addHook("MobjThinker", ghostThink, MT_SMKGV_GHOST)